"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _DomainServiceContext = require("./DomainServiceContext");

var _DomainServiceContext2 = _interopRequireDefault(_DomainServiceContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DomainComposeContext = function () {
	function DomainComposeContext(options) {
		_classCallCheck(this, DomainComposeContext);

		this.config = options.config;
		this.domainServices = options.domainServices;
		this.messages = options.messages;
		this.generatedContexts = {};
	}

	_createClass(DomainComposeContext, [{
		key: "getServiceContext",
		value: function getServiceContext(serviceName) {
			if (!this.generatedContexts[serviceName]) {
				this.generatedContexts[serviceName] = new _DomainServiceContext2.default({
					name: serviceName,
					config: _extends({}, this.config[serviceName], {
						token: this.config.token
					}),
					domainService: this.domainServices[serviceName],
					messages: this.messages
				});
			}
			return this.generatedContexts[serviceName];
		}
	}]);

	return DomainComposeContext;
}();

exports.default = DomainComposeContext;