"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _graphql = require("graphql");

var _IsIdType = require("./IsIdType");

var _IsIdType2 = _interopRequireDefault(_IsIdType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (type, fieldName) {
	if (fieldName && (0, _IsIdType2.default)(fieldName)) {
		return _graphql.GraphQLID;
	}
	switch (type) {
		case "uint32":
			return _graphql.GraphQLInt;
		case "string":
			return _graphql.GraphQLString;
	}
};