"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _grpc = require("grpc");

var _grpc2 = _interopRequireDefault(_grpc);

var _wompatti_service_grpc_pb = require("./service/wompatti_service_grpc_pb");

var _wompatti_service_grpc_pb2 = _interopRequireDefault(_wompatti_service_grpc_pb);

var _DomainServiceMethod = require("./DomainServiceMethod");

var _DomainServiceMethod2 = _interopRequireDefault(_DomainServiceMethod);

var _stringhelpers = require("./stringhelpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DomainServiceContext = function () {
	function DomainServiceContext(options) {
		_classCallCheck(this, DomainServiceContext);

		this.messages = options.messages;
		this.domainService = options.domainService;
		this.generatedMethods = {};

		var ip = options.ip,
		    port = options.port,
		    context = options.context,
		    name = options.name;


		this.client = new _wompatti_service_grpc_pb2.default[(0, _stringhelpers.capitalizeFirstLetter)(name) + "Client"](ip + ":" + port, _grpc2.default.credentials.createInsecure());
	}

	_createClass(DomainServiceContext, [{
		key: "getMethod",
		value: function getMethod(methodName) {
			if (!this.generatedMethods[methodName]) {
				this.generatedMethods[methodName] = (0, _DomainServiceMethod2.default)({
					methodName: methodName,
					messages: this.messages,
					client: this.client,
					servicePackage: this.domainService.servicePackage,
					serviceRoot: this.domainService.serviceRoot
				});
			}
			return this.generatedMethods[methodName];
		}
	}]);

	return DomainServiceContext;
}();

exports.default = DomainServiceContext;