"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var protobuf = require("protobufjs");

var ProtoLoader = function () {
	function ProtoLoader(serviceFilePath) {
		_classCallCheck(this, ProtoLoader);

		this.root = protobuf.loadSync(serviceFilePath);
	}

	_createClass(ProtoLoader, [{
		key: "findType",
		value: function findType(typeName) {
			return this.root.lookupType(typeName);
		}
	}, {
		key: "findService",
		value: function findService(serviceName) {
			return this.root.lookupService(serviceName);
		}
	}]);

	return ProtoLoader;
}();